import { OnDestroy } from "@angular/core";
import { DataTable } from "primeng/components/datatable/datatable";
import { BaseCRUDServiceInterface } from "../shared/base-interface.service";
import { Domain } from "../../shared/data/domain";
import { Item } from "../../shared/data/item";
import { DomainCachedService } from "../../shared/service/domain-cached.service";
import { TableViewService } from "../../shared/service/tableview.service";
/**
 * Clase base de los componentes TableView
 */
export declare class BaseTableViewComponent implements OnDestroy {
    dataTable: DataTable;
    items: Item[];
    totalItems: number;
    private onPageChange;
    protected dataService: BaseCRUDServiceInterface;
    protected domainCachedService: DomainCachedService;
    protected tableViewService: TableViewService;
    csvSeparator: string;
    private subscriptionMessages;
    protected RESULTADOS_PAGE: number;
    constructor(domainCachedService: DomainCachedService, tableViewService: TableViewService);
    exportCSV(): void;
    getDataTable(): DataTable;
    getColumna(record: Item, field: string): any;
    getColumnaDominio(dominio: Domain[], valor: Object): string;
    ngOnDestroy(): void;
    pageChanged(event: any): void;
    /**
     * Método de ordenación de campos de fecha.
     * @see Adaptación de: https://stackoverflow.com/questions/41181277/primeng-datatable-custom-sorting-or-filtering-angular-2
     */
    dateSort(event: any, field: any): void;
}
