"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var bit_toolbar_component_1 = require("../../..//shared/component/bit-toolbar.component");
var fromModels = require("../../models");
var base_component_1 = require("./base.component");
/**
 * Componente que implementa un listado con filtro
 * T: entidad,
 * F: Filter,
 * V: Definicion de la interface del state
 */
var BaseListComponent = /** @class */ (function (_super) {
    __extends(BaseListComponent, _super);
    function BaseListComponent(store, tableViewService, activatedRoute, factoryCreateAction) {
        var _this = _super.call(this, store) || this;
        _this.store = store;
        _this.tableViewService = tableViewService;
        _this.activatedRoute = activatedRoute;
        _this.factoryCreateAction = factoryCreateAction;
        _this.breadcrumb = [];
        _this.customToolbarActions = {};
        return _this;
    }
    /** Tenemos que ver si activamos la autobúsqueda entre otras cosas */
    BaseListComponent.prototype.ngOnInit = function () {
        console.log("ngOnInit called");
        var query = this.activatedRoute.snapshot.params["query"];
        console.log("parametro query con valor " + query);
        if (query == "true") {
            this.search(this.filter);
        }
    };
    BaseListComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
    };
    /** el componente toolbar nos comunica que se ha pulsado un botón */
    BaseListComponent.prototype.onToolbarButtonPressed = function (button) {
        console.log("Button pressed:" + button);
        if (this.customToolbarActions[button]) {
            this.customToolbarActions[button]();
        }
        else if (button === bit_toolbar_component_1.BitToolbarComponent.PRINT_BUTTON) {
            this.handlePrint();
        }
        else if (button === bit_toolbar_component_1.BitToolbarComponent.EXPORT_BUTTON) {
            this.handleExport();
        }
        else if (button === bit_toolbar_component_1.BitToolbarComponent.NEW_BUTTON) {
            this.handleNew();
        }
        else {
            this.otherAction(button);
        }
    };
    /** el componente toolbar nos comunica que se ha pulsado un botón */
    BaseListComponent.prototype.handlePrint = function () {
        window.print();
    };
    /** Cuando tenemos que exportar el listado */
    BaseListComponent.prototype.handleExport = function () {
        if (this.tableViewService) {
            this.tableViewService.sendExportMessage(); //enviamos un mensaje a un observable para que el tableview active el export
        }
        else {
            alert("Exportació no implementada per aquest llistat");
        }
    };
    /** Cuando tenemos que nagevar al formulario para crear un nuevo elemento*/
    BaseListComponent.prototype.handleNew = function () {
        this.gotoForm();
    };
    /**cualquier otra accion que no sea la típica de guardar o eliminar */
    BaseListComponent.prototype.otherAction = function (button) {
        console.warn("otherAction " + button + " pressed");
    };
    /** Se invocará cuando el componente paginator hijo nos comunique que el usuario ha cambiado el número de elementos a mostrar por página */
    BaseListComponent.prototype.onNewPageSize = function (pageSize) {
        console.log("onNewPageSize " + pageSize);
        this.filter.pagina = 1; // reseteamos a la página inicial para evitar comportamienos extraños
        this.filter.resultados = pageSize;
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.NEW_PAGE_SIZE, this.filter));
    };
    /** Se invocará cuando el componente paginator hijo nos comunique que el usuario ha cambiado el número de página a mostrar */
    BaseListComponent.prototype.onPageChange = function (page) {
        console.log("onPageChange " + page);
        this.filter.pagina = page;
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.PAGE_CHANGE, this.filter));
    };
    BaseListComponent.prototype.search = function (filter) {
        console.log("search called " + filter);
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.LOAD_ITEMS, this.filter));
    };
    BaseListComponent.prototype.reset = function (filter) {
        console.log("reset called " + filter);
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.RESET_FILTER, this.filter));
    };
    return BaseListComponent;
}(base_component_1.BaseComponent));
exports.BaseListComponent = BaseListComponent;
//# sourceMappingURL=base-list.component.js.map