import { EventEmitter, SimpleChange } from "@angular/core";
import { Store } from "@ngrx/store";
import { Observable } from "rxjs";
import { Item, FormType, MessageService } from "../../../shared";
import * as fromModels from "../../models";
import { BaseComponent } from "./base.component";
/**
 * Componente que implementa un sub listado
 * T: entidad,
 * V: Definicion de la interface del state
 */
export declare class BaseSublistComponent<T, V> extends BaseComponent<V> {
    protected store: Store<V>;
    protected messageService: MessageService;
    protected factoryCreateAction: fromModels.FactoryCreateAction;
    protected fnCreateNewObject?: fromModels.FactoryCreateNewObject<T>;
    protected fnCopyObject?: fromModels.FactoryCopyObject<T>;
    displayInnerForm$: Observable<boolean>;
    modeInnerForm$: Observable<FormType>;
    itemSelected$: Observable<T>;
    selectedItems$: Observable<number[]>;
    items$: Observable<T[]>;
    toolbar$: Observable<{}>;
    tableView: any;
    parent: any;
    parentField: string;
    initLoad: boolean;
    itemsPreloaded: Item[];
    femenino: boolean;
    forceReload: EventEmitter<any>;
    reloadFromServer: boolean;
    private onChange;
    constructor(store: Store<V>, messageService: MessageService, factoryCreateAction: fromModels.FactoryCreateAction, fnCreateNewObject?: fromModels.FactoryCreateNewObject<T>, fnCopyObject?: fromModels.FactoryCopyObject<T>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    /** Controlamos si la propiedad initLoad cambia a true para cargar la lista de documentos */
    ngOnChanges(changes: {
        [propKey: string]: SimpleChange;
    }): void;
    /** Mostramos el inner form. */
    gotoForm(data?: any): void; /** metodos de BaseSubListComponent */
    onToolbarButtonPressed(button: string): void;
    /** Cualquier otra accion que no sea la típica de guardar o eliminar */
    otherAction(action: string): void;
    deleteItem(id: number): void;
    /** Inserta o actualiza el documento */
    saveItem(item: T): void;
    loadItems(): void;
    /** nos piden cerrar el formulario */
    closeForm(event: any): void;
    /** Nos checkean algún item del listado */
    onItemChecked(selectedItems: number[]): void;
    /** Elimina los documentos seleccionados */
    deleteItems(): void;
    /** Función para hacer algo después de haber eliminado los elementos seleccionados */
    postDelete(result: any): void;
}
