"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var bit_toolbar_component_1 = require("../../../shared/component/bit-toolbar.component");
var fromModels = require("../../models");
var base_component_1 = require("./base.component");
/**
 * Componente que implementa un sub listado
 * T: entidad,
 * V: Definicion de la interface del state
 */
var BaseSublistComponent = /** @class */ (function (_super) {
    __extends(BaseSublistComponent, _super);
    function BaseSublistComponent(store, messageService, factoryCreateAction, fnCreateNewObject, fnCopyObject) {
        var _this = _super.call(this, store) || this;
        _this.store = store;
        _this.messageService = messageService;
        _this.factoryCreateAction = factoryCreateAction;
        _this.fnCreateNewObject = fnCreateNewObject;
        _this.fnCopyObject = fnCopyObject;
        _this.femenino = false; // si tenemos que mostrar los textos en femenino o no (p. ej., Nou vs Nova)
        _this.reloadFromServer = true; //indica si una vez añadido un elemento, llamaos al servidor para recargar la lista. Por defecto sí lo hace.
        _this.onChange = new core_1.EventEmitter();
        return _this;
    }
    BaseSublistComponent.prototype.ngOnInit = function () {
        this.loadItems();
    };
    BaseSublistComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
    };
    /** Controlamos si la propiedad initLoad cambia a true para cargar la lista de documentos */
    BaseSublistComponent.prototype.ngOnChanges = function (changes) {
        // console.log('BaseSublist OnChanges', changes);
        for (var propName in changes) {
            if (propName === "forceReload") {
                this.forceReload &&
                    this.forceReload.subscribe(function (x) {
                        this.loadItems();
                    }.bind(this));
            }
        }
    };
    /** Mostramos el inner form. */
    BaseSublistComponent.prototype.gotoForm = function (data) {
        console.log("showForm called");
        if (data) {
            this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.SHOW_ITEM_FOR_UPDATE, this.fnCopyObject(data)));
        }
        else {
            this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.SHOW_ITEM_FOR_INSERT, this.fnCreateNewObject(this.parent.id)));
        }
    }; /** metodos de BaseSubListComponent */
    //Nos presionan algún botón del toolbar
    BaseSublistComponent.prototype.onToolbarButtonPressed = function (button) {
        console.log("Button pressed: " + button);
        if (button === bit_toolbar_component_1.BitToolbarComponent.NEW_BUTTON) {
            this.gotoForm();
        }
        else if (button === bit_toolbar_component_1.BitToolbarComponent.DELETE_BUTTON) {
            var p = this.messageService.confirm("Està segur que vol eliminar els elements seleccionats? Aquesta acciò no es podrà desfer.");
            var local_1 = this;
            p.then(function (confirmacion) {
                if (confirmacion) {
                    local_1.deleteItems();
                }
            });
        }
        else {
            this.otherAction(button);
        }
    };
    /** Cualquier otra accion que no sea la típica de guardar o eliminar */
    BaseSublistComponent.prototype.otherAction = function (action) {
        console.warn("otherAction " + action + " pressed");
    };
    BaseSublistComponent.prototype.deleteItem = function (id) {
        console.log("deleteItem called for id " + id);
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.DELETE_ITEMS, [id]));
        //this.onChange.emit(true); <----tenemos que emitir este valor cuando se haya eliminado el elemento
    };
    /** Inserta o actualiza el documento */
    BaseSublistComponent.prototype.saveItem = function (item) {
        console.log("saveItem called for item " + item);
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.SAVE_ITEM, item));
    };
    BaseSublistComponent.prototype.loadItems = function () {
        console.log("load items called for campanya id " + this.parent.id);
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.LOAD_ITEMS, this.parent));
    };
    /** nos piden cerrar el formulario */
    BaseSublistComponent.prototype.closeForm = function (event) {
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.CLOSE_ITEM));
    };
    /** Nos checkean algún item del listado */
    BaseSublistComponent.prototype.onItemChecked = function (selectedItems) {
        console.log("element selected");
        this.store.dispatch(this.factoryCreateAction(fromModels.GENERIC_TYPE.ITEMS_SELECTED, selectedItems));
        //TODO Implementado pero no verificado
        /*
            this.selectedItems = selectedItems;
            if (this.toolbar[BitToolbarComponent.DELETE_BUTTON]) {
              if (selectedItems !== null && selectedItems.length > 0) {
                this.toolbar[BitToolbarComponent.DELETE_BUTTON].visible = true;
              } else {
                this.toolbar[BitToolbarComponent.DELETE_BUTTON].visible = false;
              }
              this.updateToolbar();
            }*/
    };
    /** Elimina los documentos seleccionados */
    BaseSublistComponent.prototype.deleteItems = function () {
        console.log("delete items"); /*
        this.store //Ojo que al borrarse los enlaces la propiedad itemsSelected se pone a [] y esta accion podría volver a dispararse
          .select(fromStore.getCampanyaEnlacesItemsSelected)
          .subscribe(enlaces => {
            if (enlaces && enlaces.length > 0) {
              this.store.dispatch(new fromStore.DeleteEnlaces(enlaces));
            } else {
              if (this.tableView != null) this.tableView.selectedItems = [];
            }
          });
          */
        //TODO Implementado pero no verificado
        /*
          this.callDeleteItems(this.parent, items).subscribe(result => {
            this.lista = this.lista.filter(item => items.indexOf("" + item.id) < 0);
            this.postDelete(result);
          });
          */
    };
    /** Función para hacer algo después de haber eliminado los elementos seleccionados */
    BaseSublistComponent.prototype.postDelete = function (result) {
        console.log("postDelete llamado");
        //TODO Implementado pero no verificado
        /*
          this.toolbar[BitToolbarComponent.DELETE_BUTTON].visible = false;
          this.updateToolbar();
          if (this.tableView != null) this.tableView.selectedItems = []; <----tenemos que actualizar este valor cuando se haya eliminado el elemento
          */
    };
    __decorate([
        core_1.ViewChild("tableview"),
        __metadata("design:type", Object)
    ], BaseSublistComponent.prototype, "tableView", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], BaseSublistComponent.prototype, "parent", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BaseSublistComponent.prototype, "parentField", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BaseSublistComponent.prototype, "initLoad", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], BaseSublistComponent.prototype, "itemsPreloaded", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BaseSublistComponent.prototype, "femenino", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", core_1.EventEmitter)
    ], BaseSublistComponent.prototype, "forceReload", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BaseSublistComponent.prototype, "reloadFromServer", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], BaseSublistComponent.prototype, "onChange", void 0);
    return BaseSublistComponent;
}(base_component_1.BaseComponent));
exports.BaseSublistComponent = BaseSublistComponent;
//# sourceMappingURL=base-sublist.component.js.map