/**
 * Clase base que contiene lo mínimo necesario para almacenar un filtro de búsqueda.
 */
export declare abstract class BaseFilter {
    resultados: number;
    pagina: number;
    static RESULTADOS_PAGE: number;
    static PAGE: number;
    static PAGE_LINK_SIZE: number;
    columnasOrdenacion: string[];
    constructor(resultados: number, pagina: number);
    reset(): void;
    /**
     * Permite obtener los valores del filtro exceptuando las propiedades pagina y resultados. Útil para inicializar el FormGroup
     * con los valores del filtro sin traernos estas propiedades que no interesan que estén en el FormGroup
     */
    formValues(): {
        [x: string]: any;
    };
}
