"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var log_exception_filter_1 = require("../shared/data/log-exception.filter");
var message_service_1 = require("../../shared/service/message.service");
var session_shared_service_1 = require("../../shared/service/session-shared.service");
var base_filter_component_1 = require("../../base/component/base-filter.component");
var base_filter_1 = require("../../base/shared/base.filter");
var custom_validators_service_1 = require("../../shared/service/custom-validators.service");
var ExceptionListFilterComponent = /** @class */ (function (_super) {
    __extends(ExceptionListFilterComponent, _super);
    function ExceptionListFilterComponent(formBuilder, messageService, sessionShared) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.messageService = messageService;
        _this.sessionShared = sessionShared;
        //gestión del filtro
        _this.filter = _this.sessionShared.get("EXCEPTION_FILTER");
        if (_this.filter === undefined) {
            _this.filter = _this.createNewFilter();
            _this.filter.pagina = base_filter_1.BaseFilter.PAGE;
            _this.filter.resultados = base_filter_1.BaseFilter.RESULTADOS_PAGE;
            _this.sessionShared.set("EXCEPTION_FILTER", _this.filter);
        }
        //construimos el form         
        _this.myForm = formBuilder.group({
            'fecha': [_this.filter.fecha, [forms_1.Validators.required, custom_validators_service_1.CustomValidators.dataValidator]],
            'desde': [_this.filter.desde, [forms_1.Validators.required]],
            'hasta': [_this.filter.hasta, [forms_1.Validators.required]]
        });
        return _this;
    }
    /** Crea un nuevo filtro para realizar la búsqueda */
    ExceptionListFilterComponent.prototype.createNewFilter = function () {
        return log_exception_filter_1.LogExceptionFilter.newObject();
    };
    ExceptionListFilterComponent = __decorate([
        core_1.Component({
            selector: 'exception-list-filter',
            template: "\n      <!-- Contenedor del filtro de búsqueda simple (siempre visible en pantalla) -->\n      <div class=\"panel panel-filtro\" [hidden]=\"!displayFilter\">\n          <div class=\"panel-heading\">\n              <i></i>&nbsp;&nbsp;&nbsp;Filtre de cerca\n          </div>\n          <form role=\"form\" [formGroup]=\"myForm\" (submit)=\"submit(myForm.value)\">\n              <div class=\"panel-body\">\n                  <div class=\"row\">\n                      <div class=\"col-xs-3\">\n                          <bit-input [(ngModel)]=\"filter.fecha\" [nombre]=\"'fecha'\" [control]=\"myForm.controls.fecha\" formControlName=\"fecha\" [tipo]=\"'date'\">&nbsp;&nbsp;Data</bit-input>\n                      </div> \n                      <div class=\"col-xs-3\">\n                          <bit-input [(ngModel)]=\"filter.desde\" [nombre]=\"'desde'\" [control]=\"myForm.controls.desde\" formControlName=\"desde\" [tipo]=\"'time'\">&nbsp;&nbsp;Des de</bit-input>\n                      </div>\n                      <div class=\"col-xs-3\">\n                          <bit-input [(ngModel)]=\"filter.hasta\" [nombre]=\"'hasta'\" [control]=\"myForm.controls.hasta\" formControlName=\"hasta\" [tipo]=\"'time'\">&nbsp;&nbsp;Fins a</bit-input>\n                      </div>\n                      <div class=\"col-xs-3\">\n                          <bit-input [(ngModel)]=\"filter.login\" [nombre]=\"'login'\" [ngModelOptions]=\"{standalone: true}\" [tipo]=\"'text'\">&nbsp;&nbsp;Login</bit-input>\n                      </div>\n                  </div>\n              </div>\n              <div class=\"panel-footer text-center\">\n                  <div class=\"btn-group\" role=\"group\">\n                      <button type=\"reset\" (click)=\"resetFilter()\" class=\"btn btn-default\">Neteja&nbsp;&nbsp;<span class=\"glyphicon glyphicon-erase\"></span></button>\n                  </div>\n                  <div class=\"btn-group\" role=\"group\">\n                      <button type=\"submit\" class=\"btn btn-success\">Cerca&nbsp;&nbsp;<span class=\"glyphicon glyphicon-search\"></span></button>\n                  </div>\n              </div>\n          </form>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder,
            message_service_1.MessageService,
            session_shared_service_1.SessionSharedService])
    ], ExceptionListFilterComponent);
    return ExceptionListFilterComponent;
}(base_filter_component_1.BaseFilterComponent));
exports.ExceptionListFilterComponent = ExceptionListFilterComponent;
//# sourceMappingURL=exception-list-filter.component.js.map