"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var exception_list_filter_component_1 = require("./exception-list-filter.component");
var developer_service_1 = require("../shared/service/developer.service");
var message_service_1 = require("../../shared/service/message.service");
var toolbar_service_1 = require("../../shared/service/toolbar.service");
var base_list_component_1 = require("../../base/component/base-list.component");
/**
 * Componente que implementa el listado de errores de aplicación para auditoría.
 * Permite consultar las exception que se han producido en la App.
 **/
var ExceptionListComponent = /** @class */ (function (_super) {
    __extends(ExceptionListComponent, _super);
    function ExceptionListComponent(developerService, messageService, toolbarService, activatedRoute, router) {
        var _this = _super.call(this, developerService, messageService, activatedRoute, router) || this;
        _this.developerService = developerService;
        _this.messageService = messageService;
        _this.toolbarService = toolbarService;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.breadcrumb.push({ label: 'Developer' });
        _this.breadcrumb.push({ label: 'Exceptions' });
        return _this;
    }
    /** Tenemos que ver si activamos la autobúsqueda entre otras cosas */
    ExceptionListComponent.prototype.ngOnInit = function () {
        _super.prototype.init.call(this, this.exceptionListFilterComponent.filter);
    };
    /** Preparampos los datos antes de enviarlos al servidor */
    ExceptionListComponent.prototype.prepareDataForSubmit = function () {
        // nothing to do
    };
    __decorate([
        core_1.ViewChild(exception_list_filter_component_1.ExceptionListFilterComponent),
        __metadata("design:type", exception_list_filter_component_1.ExceptionListFilterComponent)
    ], ExceptionListComponent.prototype, "exceptionListFilterComponent", void 0);
    ExceptionListComponent = __decorate([
        core_1.Component({
            selector: 'exception-list',
            template: "   \n   <bit-header [breadcrumb]=breadcrumb (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n   <exception-list-filter [displayFilter]=\"true\" (onSearch)=\"onSearch($event)\" (onReset)=onReset($event)></exception-list-filter>\n   <exception-list-tableview [items]=items></exception-list-tableview>\n   <bit-footer [autoQueryObs]=\"autoQuerySubject.asObservable()\" [totalItems]=\"totalItems\" [status]=\"status\" type=\"list\" [paginator]=\"true\" (onPageChange)=\"onPageChange($event)\" (onNewPageSize)=\"onNewPageSize($event)\"></bit-footer>\n   "
        }),
        __metadata("design:paramtypes", [developer_service_1.DeveloperService,
            message_service_1.MessageService,
            toolbar_service_1.ToolbarService,
            router_1.ActivatedRoute,
            router_1.Router])
    ], ExceptionListComponent);
    return ExceptionListComponent;
}(base_list_component_1.BaseListComponent));
exports.ExceptionListComponent = ExceptionListComponent;
//# sourceMappingURL=exception-list.component.js.map