import { OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { LogService } from '../shared/service/log.service';
import { LogFilter } from '../shared/data/log.filter';
import { MessageService } from '../../shared/service/message.service';
import { BaseListComponent } from '../../base/component/base-list.component';
/**
 * Componente que implementa el listado de log para auditoría.
 * Permite consultar todas las acciones que han realizad o los usuarios en la aplicación.
 **/
export declare class LogListNoFiltroComponent extends BaseListComponent implements OnInit {
    protected logService: LogService;
    protected messageService: MessageService;
    protected activatedRoute: ActivatedRoute;
    protected router: Router;
    protected filter: LogFilter;
    constructor(logService: LogService, messageService: MessageService, activatedRoute: ActivatedRoute, router: Router);
    /** Construimos un filtro manual, desactivamos el botón de filtro del toolbar y buscamos 50 elementos sin paginación*/
    ngOnInit(): any;
    /** Preparampos los datos antes de enviarlos al servidor */
    prepareDataForSubmit(): void;
}
