"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var fichero_1 = require("../data/fichero");
var bitmessage_1 = require("../data/bitmessage");
var upload_service_1 = require("../service/upload.service");
var message_service_1 = require("../service/message.service");
var BitFormUploadComponent = /** @class */ (function () {
    function BitFormUploadComponent(uploadService, messageService, downloadUrlVariable) {
        this.uploadService = uploadService;
        this.messageService = messageService;
        this.downloadUrlVariable = downloadUrlVariable;
        this.id = "file";
        this.puedeAbrir = true;
        this.onFilesUpload = new core_1.EventEmitter();
        this.uploading = false;
        this.resetUpload = new core_1.EventEmitter(); // para avisar a bitupload de que resetee su formulario
        BitFormUploadComponent_1.DOWNLOAD_URL = downloadUrlVariable;
    }
    BitFormUploadComponent_1 = BitFormUploadComponent;
    BitFormUploadComponent.prototype.ngOnInit = function () { };
    BitFormUploadComponent.prototype.fileChange = function (files) {
        this.filesToUpload = files;
    };
    // para utilizar desde la propia plantilla
    BitFormUploadComponent.prototype.downloadUrl = function (id) {
        return BitFormUploadComponent_1.getUrlDownloadFile(id);
    };
    // para utilizar desde otro componente
    BitFormUploadComponent.getUrlDownloadFile = function (id) {
        return BitFormUploadComponent_1.DOWNLOAD_URL + 'ficheros/download/' + id;
    };
    BitFormUploadComponent.prototype.submit = function () {
        var _this = this;
        console.log("submit upload files");
        this.uploading = true;
        this.uploadService.upload(null, this.filesToUpload, this.params).then(function (result) {
            _this.uploading = false;
            console.log(result);
            var jsonArray = eval("(" + result + ")");
            //this.messageService.sendNotification(new BitMessage("Informació", "S'ha pujat el fitxer correctament al servidor"));
            _this.resetUpload.emit(true); //comunicamos a bit-upload que resetee la información de los ficheros cargados
            _this.onFilesUpload.emit(jsonArray); //comunicamos hacia arriba el resultado satisfactorio de la operación
            if (_this.multiple) {
                _this.fileList = jsonArray;
            }
            else {
                _this.simpleFile = jsonArray[0];
            }
        }, function (error) {
            _this.uploading = false;
            console.log(error);
            var objError = JSON.parse(error);
            _this.messageService.sendNotification(new bitmessage_1.BitMessage("Error", objError.text, undefined, undefined, undefined, bitmessage_1.BitMessage.ERROR));
            _this.onFilesUpload.emit(null);
            _this.fileList = [];
            _this.simpleFile = null;
        });
    };
    BitFormUploadComponent.createNewParamsObject = function (tipoFichero) {
        var paramsUploadFile = {};
        paramsUploadFile['tipoFichero'] = tipoFichero;
        return paramsUploadFile;
    };
    BitFormUploadComponent.addCarpetaToParamsObject = function (paramsUploadFile, carpeta) {
        paramsUploadFile['carpeta'] = carpeta;
    };
    BitFormUploadComponent.addIdToParamsObject = function (paramsUploadFile, id) {
        paramsUploadFile['id'] = id;
    };
    BitFormUploadComponent.addTipoFicheroToParamsObject = function (paramsUploadFile, tipoFichero) {
        paramsUploadFile['tipoFichero'] = tipoFichero;
    };
    var BitFormUploadComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], BitFormUploadComponent.prototype, "params", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitFormUploadComponent.prototype, "showFiles", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitFormUploadComponent.prototype, "id", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitFormUploadComponent.prototype, "multiple", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitFormUploadComponent.prototype, "searchLabel", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitFormUploadComponent.prototype, "soloLectura", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", fichero_1.Fichero)
    ], BitFormUploadComponent.prototype, "simpleFile", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], BitFormUploadComponent.prototype, "fileList", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitFormUploadComponent.prototype, "puedeAbrir", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], BitFormUploadComponent.prototype, "onFilesUpload", void 0);
    BitFormUploadComponent = BitFormUploadComponent_1 = __decorate([
        core_1.Component({
            selector: 'bit-form-upload',
            template: "\n    <form method=\"post\" enctype=\"multipart/form-data\" (submit)=\"submit()\" style=\"display: inline;\">\n        <div *ngIf=\"fileList != null && fileList.length > 0 && showFiles && multiple\" class=\"col-sm-4\">\n            <a *ngFor=\"let file of fileList; let i=index;\" \n                target=\"_blank\" href=\"{{downloadUrl(file.id)}}\">\n                {{file.nombre}}\n            </a>\n        </div>\n        <div *ngIf=\"simpleFile != null && showFiles && !multiple\" class=\"col-sm-4\">\n            <a *ngIf=\"puedeAbrir\" target=\"_blank\" href=\"{{downloadUrl(simpleFile.id)}}\">\n                {{simpleFile.nombre}}\n            </a>\n            <span *ngIf=\"!puedeAbrir\">{{simpleFile.nombre}}</span>\n        </div>\n        <div *ngIf=\"!soloLectura\" class=\"col-sm-8\">\n            <bit-upload \n                [uploading]=uploading\n                [reset]=\"resetUpload\" \n                (onFileChange)=\"fileChange($event)\" \n                [showFiles]=true \n                [multiple]=multiple \n                [id]=\"id\">\n            </bit-upload>\n        </div>\n    </form>\n"
        }),
        __param(2, core_1.Inject("DOWNLOAD_URL")),
        __metadata("design:paramtypes", [upload_service_1.UploadService,
            message_service_1.MessageService, String])
    ], BitFormUploadComponent);
    return BitFormUploadComponent;
}());
exports.BitFormUploadComponent = BitFormUploadComponent;
//# sourceMappingURL=bit-form-upload.component.js.map