"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
/**
 * Componenente que muestra una barra de botones.
 **/
var BitStoreToolbarComponent = /** @class */ (function () {
    function BitStoreToolbarComponent() {
        this.femenino = false; // género femenino (para los nombres de botones) o no
        this.otherActionsDropdown = false; // determina si las "other actions" deben mostrarse en línea o como un desplegable
        this.onToolbarButtonPressed = new core_1.EventEmitter();
    }
    BitStoreToolbarComponent_1 = BitStoreToolbarComponent;
    BitStoreToolbarComponent.prototype.enable = function (button) {
        return this.toolbar[button] && this.toolbar[button].enable;
    };
    BitStoreToolbarComponent.prototype.visible = function (button) {
        return this.toolbar[button] && this.toolbar[button].visible;
    };
    BitStoreToolbarComponent.prototype.label = function (button, defaultLabel) {
        return (this.toolbar[button] && this.toolbar[button].label) || defaultLabel;
    };
    BitStoreToolbarComponent.prototype.estilo = function (button, defaultValue) {
        return ((this.toolbar[button] && this.toolbar[button].estilo) ||
            defaultValue ||
            "fa fa-balance-spinner");
    };
    BitStoreToolbarComponent.prototype.showFilter = function () {
        this.onToolbarButtonPressed.emit(BitStoreToolbarComponent_1.FILTER_BUTTON);
    };
    BitStoreToolbarComponent.prototype.print = function () {
        this.onToolbarButtonPressed.emit(BitStoreToolbarComponent_1.PRINT_BUTTON);
    };
    BitStoreToolbarComponent.prototype.exportData = function () {
        this.onToolbarButtonPressed.emit(BitStoreToolbarComponent_1.EXPORT_BUTTON);
    };
    BitStoreToolbarComponent.prototype.newElement = function () {
        this.onToolbarButtonPressed.emit(BitStoreToolbarComponent_1.NEW_BUTTON);
    };
    BitStoreToolbarComponent.prototype.add = function () {
        this.onToolbarButtonPressed.emit(BitStoreToolbarComponent_1.ADD_BUTTON);
    };
    BitStoreToolbarComponent.prototype.save = function () {
        this.onToolbarButtonPressed.emit(BitStoreToolbarComponent_1.SAVE_BUTTON);
    };
    BitStoreToolbarComponent.prototype.delete = function () {
        this.onToolbarButtonPressed.emit(BitStoreToolbarComponent_1.DELETE_BUTTON);
    };
    BitStoreToolbarComponent.prototype.otherAction = function (button) {
        this.onToolbarButtonPressed.emit(button.action);
    };
    /** escuchamos cuando la toolbar cambia para ajustar las other Actions */
    BitStoreToolbarComponent.prototype.ngOnChanges = function (changes) {
        for (var propName in changes) {
            var changedProp = changes[propName];
            if (propName === "toolbar") {
                var newToolbar = changedProp.currentValue;
                console.log("nueva toolbar proporcionada " + newToolbar);
                this.toolbar = newToolbar;
                // calcular si las other actions deben mostrarse en desplegable
                // (se ha pedido asi y hay más de una)
                var otherActionsVisibles = 0;
                for (var key in this.toolbar) {
                    if (this.toolbar[key].otherAction && this.toolbar[key].visible) {
                        otherActionsVisibles++;
                    }
                }
                this.mostrarOtherActionsEnDesplegable =
                    this.otherActionsDropdown && otherActionsVisibles > 1;
            }
        }
    };
    var BitStoreToolbarComponent_1;
    BitStoreToolbarComponent.FILTER_BUTTON = "filter";
    BitStoreToolbarComponent.PRINT_BUTTON = "print";
    BitStoreToolbarComponent.EXPORT_BUTTON = "export";
    BitStoreToolbarComponent.NEW_BUTTON = "new";
    BitStoreToolbarComponent.SAVE_BUTTON = "save";
    BitStoreToolbarComponent.DELETE_BUTTON = "delete";
    BitStoreToolbarComponent.ADD_BUTTON = "add";
    BitStoreToolbarComponent.HELP_BUTTON = "help";
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], BitStoreToolbarComponent.prototype, "toolbar", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitStoreToolbarComponent.prototype, "ayuda", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitStoreToolbarComponent.prototype, "femenino", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitStoreToolbarComponent.prototype, "otherActionsDropdown", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], BitStoreToolbarComponent.prototype, "onToolbarButtonPressed", void 0);
    BitStoreToolbarComponent = BitStoreToolbarComponent_1 = __decorate([
        core_1.Component({
            selector: "bit-store-toolbar",
            changeDetection: core_1.ChangeDetectionStrategy.OnPush,
            template: "\n    <!-- acciones no estandar definidas dinámicamente o muy particulares-->\n    <!-- si otherActionsDropdown viene a true y hay más de una acción, se muestran como un desplegable, si no, todas las acciones en línea -->\n    <div class=\"btn-group dropdown\" role=\"group\" *ngIf=\"mostrarOtherActionsEnDesplegable\">\n            <button type=\"button\" *ngIf=\"otherActionsDropdown\"\n                class=\"btn btn-dinamico btn-accion dropdown-toggle\" data-toggle=\"dropdown\"\n                aria-haspopup=\"true\" aria-expanded=\"false\">Accions&nbsp;&nbsp;<span class=\"fa fa-caret-right\"></span></button>\n            <div class=\"dropdown-menu desplegable-accion\">\n                <ng-container *ngFor=\"let button of (toolbar | otherToolbarAction)\">\n                    <button type=\"button\" \n                        *ngIf=\"button.visible\"\n                        [disabled]=\"!button.enable\" (click)=\"otherAction(button)\" class=\"btn btn-dinamico btn-accion dropdown-item\"\n                    ><span [class]=\"button.estilo?button.estilo:'fa fa-caret-right'\"></span>&nbsp;&nbsp;{{button.label}}</button>\n                </ng-container>\n            </div>\n        </div>\n    \n        <!-- si otherActionsDropdown viene a false o solo hay una acción, se muestran una tras otra en línea -->\n        <div class=\"btn-inline\" *ngIf=\"!mostrarOtherActionsEnDesplegable\">\n            <ng-container *ngFor=\"let button of (toolbar | otherToolbarAction)\">\n                <div *ngIf=\"button.visible\" class=\"btn-group\" role=\"group\">\n                    <button type=\"button\" [disabled]=\"!button.enable\" (click)=\"otherAction(button)\" class=\"btn btn-dinamico btn-accion\">{{button.label}}&nbsp;&nbsp;<span [class]=\"button.estilo?button.estilo:'fa fa-caret-right'\"></span></button>\n                </div>\n            </ng-container>\n        </div>\n    \n        <!-- acciones estandar -->\n        <div class=\"btn-group\" role=\"group\" *ngIf=\"visible('new')\">\n            <button type=\"button\" [disabled]=\"!enable('new')\" (click)=\"newElement()\" class=\"btn btn-danger\">{{label('new', (femenino?'Nova':'Nou'))}}&nbsp;&nbsp;<span [class]=\"estilo('new', 'fa fa-plus')\"></span></button>\n        </div>\n        <div class=\"btn-group\" role=\"group\" *ngIf=\"visible('add')\">\n            <button type=\"button\" [disabled]=\"!enable('add')\" (click)=\"add()\" class=\"btn btn-danger\">{{label('nova', 'Afegeix')}}&nbsp;&nbsp;<span [class]=\"estilo('add', 'fa fa-plus')\"></span></button>\n        </div>\n        <!--div class=\"btn-group\" role=\"group\" *ngIf=\"visible('filter')\">\n            <button type=\"button\" [disabled]=\"!enable('filter')\" (click)=\"showFilter()\" class=\"btn btn-transparent\">{{label('filter', 'Mostra filtre')}}&nbsp;&nbsp;<span [class]=\"estilo('filter', 'glyphicon glyphicon-search')\"></span></button>\n        </div-->\n        <div class=\"btn-group\" role=\"group\" *ngIf=\"visible('export')\">\n            <button type=\"button\" [disabled]=\"!enable('export')\" (click)=\"exportData()\" class=\"btn btn-transparent\">{{label('export', 'Exporta')}}&nbsp;&nbsp;<span [class]=\"estilo('export', 'glyphicon glyphicon-file')\"></span></button>\n        </div>\n        <div class=\"btn-group\" role=\"group\" *ngIf=\"visible('save')\">\n            <button type=\"button\" [disabled]=\"!enable('save')\" (click)=\"save()\" class=\"btn btn-success\">{{label('save', 'Desa')}}&nbsp;&nbsp;<span [class]=\"estilo('save', 'glyphicon glyphicon-floppy-disk')\"></span></button>\n        </div>\n        <div class=\"btn-group\" role=\"group\" *ngIf=\"visible('delete')\">\n            <button type=\"button\" [disabled]=\"!enable('delete')\" (click)=\"delete()\" class=\"btn btn-transparent btn-transparent-danger\">{{label('delete', 'Elimina')}}&nbsp;&nbsp;<span [class]=\"estilo('delete', 'glyphicon glyphicon-remove')\"></span></button>\n        </div>\n        <div class=\"btn-group\" role=\"group\" *ngIf=\"visible('print')\">\n            <button type=\"button\" [disabled]=\"!enable('print')\" (click)=\"print()\" class=\"btn btn-transparent\">{{label('print', 'Imprimeix')}}&nbsp;&nbsp;<span [class]=\"estilo('print', 'glyphicon glyphicon-print')\"></span></button>\n        </div>\n        <div class=\"btn-group\" role=\"group\" *ngIf=\"ayuda\">\n            <bit-boton-ayuda boton=\"true\" [ayuda]=\"ayuda\"></bit-boton-ayuda>\n        </div>\n  "
        })
    ], BitStoreToolbarComponent);
    return BitStoreToolbarComponent;
}());
exports.BitStoreToolbarComponent = BitStoreToolbarComponent;
//# sourceMappingURL=bit-store-toolbar.component.js.map