"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
/**
 *  Clase general que todos los componentes personalizados deben extender. Contiene toda la lógica común para trabajar con
 * componentes personalizados
 */
var BitGeneralComponent = /** @class */ (function () {
    function BitGeneralComponent(ayudaService) {
        this.ayudaService = ayudaService;
        this.placeholder = "";
        this.readOnly = false;
        this.hideLabel = false; // forzar que no se reserve espacio para el nombre del campo
        this.forceObligatorio = false;
        this.onChange = new core_1.EventEmitter();
    }
    /**Debemos suscribirnos a los cambios del FormControl para emitir mediante onChange el evento con el nuevo valor que tiene el componente */
    BitGeneralComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.control) {
            this.control.valueChanges.subscribe(function (value) {
                _this.onChange.emit(value);
            });
        }
        else {
            console.log("control no definido para " + this.nombre);
        }
    };
    /** Controlamos si debemos modificar el valor interno del componente mediante una transformacion al tener un pipe asociado*/
    BitGeneralComponent.prototype.onBlur = function () {
        if (this.instanciaPipe != null) {
            this.control.setValue(this.instanciaPipe.transform(this.control.value));
        }
    };
    BitGeneralComponent.prototype.onFocus = function () {
        if (this.instanciaPipe != null) {
            this.control.setValue(this.instanciaPipe.parse(this.control.value));
            this.control.updateValueAndValidity();
        }
    };
    Object.defineProperty(BitGeneralComponent.prototype, "obligatorio", {
        // decidimos marcar el campo como obligatorio si se ha indicado a la fuerza (por parámetro)
        // o si el control de formulario asociado está saltando por ser obligatorio y no haberse rellenado
        get: function () {
            return this.forceObligatorio || (this.control && this.control.errors && this.control.errors["required"]);
        },
        enumerable: true,
        configurable: true
    });
    BitGeneralComponent.prototype.showAyuda = function () {
        this.ayudaService.mostrarAyuda(this.ayuda);
    };
    Object.defineProperty(BitGeneralComponent.prototype, "value_lectura", {
        get: function () {
            return this.control.value;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", forms_1.FormControl)
    ], BitGeneralComponent.prototype, "control", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], BitGeneralComponent.prototype, "nombre", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], BitGeneralComponent.prototype, "nombreDirectiva", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitGeneralComponent.prototype, "label", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitGeneralComponent.prototype, "estilo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitGeneralComponent.prototype, "tooltipTexto", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitGeneralComponent.prototype, "tooltipPosicion", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitGeneralComponent.prototype, "ayuda", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], BitGeneralComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitGeneralComponent.prototype, "readOnly", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitGeneralComponent.prototype, "hideLabel", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], BitGeneralComponent.prototype, "instanciaPipe", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BitGeneralComponent.prototype, "forceObligatorio", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], BitGeneralComponent.prototype, "onChange", void 0);
    return BitGeneralComponent;
}());
exports.BitGeneralComponent = BitGeneralComponent;
//# sourceMappingURL=bit-general.component.js.map