import { OnInit, ChangeDetectorRef } from "@angular/core";
import { ActivatedRoute } from "@angular/router";
import { AyudaService } from "../../service/ayuda.service";
import { SessionSharedService } from "../../service/session-shared.service";
import { BitCustomComponent } from "./bit-custom.component";
/**
 * Clase que utiliza un custom componente para select de elementos
 * Utiliza la interfaz ControlValueAccessor
 *    <bit-select [domain]="'DOMAIN_TIPO_LOG'" id="tipolog" [control]="formControl">&nbsp;&nbsp;Tipus d'operació</bit-select>
 *
 * @input data: array de objetos a mostrar en el select. Puede ser null, en cuyo caso domain no puede ser null
 * @input domain: nombre del dominio que contiene los datos y que nos resolverá la página cuando cargue el componente. Puede ser null, en cuyo caso data no puede ser null
 * @input id: identificador del componente select
 * @input filter: true indicará que podemos buscar dentro del select, false que no.
 **/
export declare abstract class BitDropDownGeneralComponent extends BitCustomComponent implements OnInit {
    protected router: ActivatedRoute;
    protected sessionShared: SessionSharedService;
    protected ayudaService: AyudaService;
    protected changeDetectorRef: ChangeDetectorRef;
    hideLabel: boolean;
    data: any[];
    domain: string;
    listaOpciones: any[];
    listaOpcionesVisible: any[];
    constructor(router: ActivatedRoute, sessionShared: SessionSharedService, ayudaService: AyudaService, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    abstract postRetrieveData(): any;
    onBlur(): void;
    onFocus(): void;
}
