"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ayudacontextual_1 = require("../data/ayudacontextual");
var AyudaService = /** @class */ (function () {
    function AyudaService() {
        this.mostrar = new core_1.EventEmitter();
        this.loadAyudas();
    }
    AyudaService_1 = AyudaService;
    // procesa el fichero app.ayudas.json y crea el mapa para acceder luego directamente por clave
    AyudaService.prototype.loadAyudas = function () {
        var _this = this;
        this.mapaAyudas = new Map();
        if (AyudaService_1.AYUDAS) {
            AyudaService_1.AYUDAS.forEach(function (elem) {
                _this.mapaAyudas.set(elem.key, ayudacontextual_1.AyudaContextual.newObject(elem));
            });
            console.log("Cargadas " + this.mapaAyudas.size + " ayudas contextuales");
        }
        else {
            console.warn('No se han podido cargar las ayudas contextuales de la aplicacion.');
        }
    };
    AyudaService.prototype.mostrarAyuda = function (key) {
        if (this.mapaAyudas.has(key)) {
            this.mostrar.emit(this.mapaAyudas.get(key));
        }
        else {
            console.warn("No existe ayuda para la clave [" + key + "]");
        }
    };
    var AyudaService_1;
    AyudaService.AYUDAS = []; // Inicializar desde la aplicacion cliente
    AyudaService = AyudaService_1 = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [])
    ], AyudaService);
    return AyudaService;
}());
exports.AyudaService = AyudaService;
//# sourceMappingURL=ayuda.service.js.map